/* Problem URL: https://codeforces.com/contest/2173/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    ll n, k;
    cin >> n >> k;

    if (k == 0) {
        cout << "0\n";
        return;
    }

    // vi count(n);
    // int c = 0;
    // nrep(i, 1, 30) {
    //     if (~(n >> i) & 1) {
    //         count.push_back(c);
    //         c = 0;
    //         continue;
    //     }
    //
    //     c++;
    // }
    //
    // count.push_back(c);
    // sort(all(count), greater<>());
    //
    // ll ans = 0;
    //

    int act = min(k, 30LL);
    
    // vvvl memo(31, vvl(act + 1, vl(2, -1)));
    //
    // function<ll(int, int, int)> dp = [&](int i, int k, int c) {
    //     if (i >= 31) {
    //         return 0LL;
    //     }
    //
    //     ll &ans = memo[i][k][c];
    //     if (ans != -1) {
    //         return ans;
    //     }
    //
    //     if (c == 1 && ((n >> i) & 1)) {
    //         return ans = dp(i + 1, k, 1) + 1;
    //     }
    //
    //     if (k == 0) {
    //         return ans = 0LL;
    //     }
    //
    //     if (((n >> i) & 1) || c == 1) {
    //         return ans = max(dp(i + 1, k, 0), dp(i + 1, k - 1, 1) + 1);
    //     }
    //
    //     return ans = dp(i + 1, k, 0);
    // };

    // dp(0, act, 0);

    vvvl dp(31, vvl(act + 1, vl(2, -OO)));
    dp[0][0][0] = 0;

    if (n & 1) {
        dp[0][1][1] = 1;
    }

    nrep(i, 1, 31) {
        dp[i][0][0] = dp[i - 1][0][0];
        if ((n >> i) & 1) {
            dp[i][1][1] = max(dp[i - 1][1][1], dp[i - 1][0][0]) + 1;
        } else {
            dp[i][1][0] = max(dp[i - 1][1][1], dp[i - 1][0][0]);
        }

        nrep(j, 1, act + 1) {
            dp[i][j][0] = max(dp[i - 1][j][0], dp[i - 1][j][1]);

            if ((n >> i) & 1) {
                dp[i][j][1] = max(dp[i - 1][j - 1][0], dp[i - 1][j][1]) + 1;
                continue;
            }

            dp[i][j][1] = dp[i - 1][j - 1][1] + 1;
            if (j > 1) {
                rmax(dp[i][j][1], dp[i - 1][j - 2][0] + 1);
            }
        }
    }

    ll ans = 0;
    rep(i, 31) {
        rep(j, act + 1) {
            rmax(ans, dp[i][j][0] + k - j);
            rmax(ans, dp[i][j][1] + k - j);
        }
    }

    cout << ans << '\n';

    // rep(i, 30) {
    //     rep(j, act + 1) {
    //         if (memo[i][j][0] != -1) {
    //             rmax(ans, memo[i][j][0] + k - j);
    //         }
    //
    //         if (memo[i][j][1] != -1) {
    //             rmax(ans, memo[i][j][1] + k - j);
    //         }
    //     }
    // }
    //
    // cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
